unit LogoMain;

interface

uses Windows, ShellAPI, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, StdActns,
  ActnList, ToolWin, CheckLst, OleCtrls, SHDocVw, FileCtrl, Spin;

type
  TAppForm = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ActionList1: TActionList;
    FileOpen1: TAction;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    FileExit1: TAction;
    HelpAbout1: TAction;
    StatusBar: TStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    N2: TMenuItem;
    FileExitItem: TMenuItem;
    Help1: TMenuItem;
    HelpAboutItem: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    Splitter1: TSplitter;
    PopupMenu1: TPopupMenu;
    BuiltBrowser1: TMenuItem;
    DefaultBrowser1: TMenuItem;
    PopupMenu2: TPopupMenu;
    BuiltinBrowser1: TMenuItem;
    DefaultBrowser2: TMenuItem;
    Optimize1: TAction;
    Undo1: TAction;
    Results1: TAction;
    Before1: TAction;
    After1: TAction;
    Edit1: TMenuItem;
    Preview1: TMenuItem;
    Op1: TMenuItem;
    Undo2: TMenuItem;
    Before2: TMenuItem;
    After2: TMenuItem;
    Setting1: TAction;
    N1: TMenuItem;
    Setting2: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    Panel3: TPanel;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    ToolButton4: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ComboBox1: TComboBox;
    Panel4: TPanel;
    FilterComboBox1: TFilterComboBox;
    DriveComboBox1: TDriveComboBox;
    RichEdit1: TRichEdit;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton3: TToolButton;
    ToolButton14: TToolButton;
    N3: TMenuItem;
    Results2: TMenuItem;
    ToolBar2: TToolBar;
    Copy1: TToolButton;
    Move1: TToolButton;
    Rename1: TToolButton;
    ToolButton15: TToolButton;
    Del1: TToolButton;
    ToolButton17: TToolButton;
    View1: TToolButton;
    N4: TMenuItem;
    Close1: TMenuItem;
    Close2: TAction;
    WebBrowser1: TWebBrowser;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    Stop2: TAction;
    Stop1: TMenuItem;
    Label4: TLabel;
    SpinEdit1: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileSaveAs1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WebBrowser1ProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure DefaultBrowser1Click(Sender: TObject);
    procedure DefaultBrowser2Click(Sender: TObject);
    procedure Optimize1Execute(Sender: TObject);
    procedure Undo1Execute(Sender: TObject);
    procedure Results1Execute(Sender: TObject);
    procedure Before1Execute(Sender: TObject);
    procedure After1Execute(Sender: TObject);
    procedure Setting1Execute(Sender: TObject);
    procedure ToolButton14Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Move1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure Del1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Close2Execute(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FileListBox1Click(Sender: TObject);
    procedure Stop2Execute(Sender: TObject);
  private
    { Private Declarations}
  TempFile: String;
  B: LongInt;
  OptStart, OptFin: TDateTime;
  procedure FindAndReplace;
  procedure FindDeadLink;
  procedure ResetAll;
  procedure FileChange(Sender: TObject);
  public
    { Public declarations }
  FindList, RepList, OnOff: TListBox;
  LinkStPos, LinkEndPos: LongInt;
  FFileName, FileExName, PathName, FindTxt, ReplaceTxt: String;
  StartPos, ToEnd, SkipLinkCount, DeadLinkCount: Integer;
  Stop: boolean;
  procedure RefreshGrid;
  end;

var
  AppForm: TAppForm;

implementation

uses SysUtils, About, Result, SetForm, Unit1, Unit4;

{$R *.DFM}

resourcestring
  SOverwrite = 'OK to overwrite %s';

procedure TAppForm.ResetAll;
begin
  Optimize1.Enabled := true;
  B := 0;
  DeadLinkCount := 0;
  SkipLinkCount := 0;
  Undo1.Enabled := false;
  Results1.Enabled := false;
  Before1.Enabled := true;
  After1.Enabled := true;
  Stop := false;
  if ComboBox1.Items.Count > 25 then ComboBox1.Items.Delete(25);
  ComboBox1.Items.Add(FFileName);
end;

procedure TAppForm.FileChange(Sender: TObject);
begin
if FFileName  <> '' then with ChangeDlg do
  begin
    if Sender = Move1 then Caption := 'Move'
    else if Sender = Copy1 then Caption := 'Copy'
    else if Sender = Rename1 then Caption := 'Rename'
    else Exit;
    CurrentDir.Caption := AppForm.DirectoryListBox1.Directory;
    FromFileName.Text := FFileName;
    ToFileName.text := FFileName;
    ListBox1.Items.LoadFromFile(ExtractFilePath(Application.ExeName)+'folders.ini');
    if (ShowModal <> mrCancel) and (ToFileName.Text <> '') then
    //*************
    begin
      ListBox1.Items.Add(CurrentDir.Caption);
      if MessageDlg(Format('%s %s to %s?', [Caption, FromFileName.text, ToFileName.text]),
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if Caption = 'Move' then
      MoveFile(PChar(FromFileName.text), PChar(ToFileName.text))
    else if Caption = 'Copy' then
      CopyFile( PChar(FromFileName.text), PChar(ToFileName.text) ,true)
    else if Caption = 'Rename' then
      RenameFile(PChar(FromFileName.text), PChar(ToFileName.text));
  end;
    end;
    //************
    ListBox1.Items.SaveToFile(ExtractFilePath(Application.ExeName)+'folders.ini');
    FileListBox1.Update;
  end;

end;


procedure TAppForm.FindAndReplace;
var
SelPos: integer;
begin
{show total lines and make visible current lines}
Label2.Visible := true;
Label3.Visible := true;
{locate the selected text position}
SelPos := RichEdit1.FindText(FindTxt, 0, Length(RichEdit1.Text),[]);
{if the FindTxt is found in Richedit1 then repeat...}
while SelPos <> -1 do
 begin
   {stop process}
   if Stop = true then Exit;
   {show current lines}
   Label2.Caption := Format('Total characters count:  %d', [Length(RichEdit1.Lines.Text)]);
   Label3.Caption := Format('Currently scanning at:  %d', [RichEdit1.SelStart]);
   {found text starts on one character before the SelPos}
   RichEdit1.SelStart := SelPos;
   RichEdit1.SelLength := Length(FindTxt);
   RichEdit1.SelText := ReplaceTxt;
   {"B" shows how many times the process has repeated}
   {we will need this in Results form to show how many entries have been replaced or deleted}
   B := B + 1;
   SelPos := RichEdit1.FindText(FindTxt, 0, Length(RichEdit1.Text),[]);
   Application.ProcessMessages;
 end;
end;

procedure TAppForm.FindDeadLink;
label Home;
begin
LinkStPos := RichEdit1.FindText(FindTxt, 0, Length(RichEdit1.Text),[]);
StartPos := 0;
  Home:
  while LinkStPos <> -1 do
  begin
    {stop process}
    if Stop = true then Exit;
    ToEnd := Length(RichEdit1.Text);{the length of text}
    LinkStPos := RichEdit1.FindText(FindTxt, StartPos, ToEnd,[]);
    StartPos := LinkStPos+1;
    LinkEndPos := RichEdit1.FindText(ReplaceTxt, StartPos + Length(FindTxt), ToEnd,[]);
    if LinkStPos <> -1 then if LinkEndPos <> -1 then{if both found}
    begin
      RichEdit1.SelStart := LinkStPos + Length(FindTxt);{because of <a href="}
      RichEdit1.SelLength := LinkEndPos - LinkStPos - Length(FindTxt);
      {link is a full file name with path}
      PathName := RichEdit1.SelText;
      DeadLinkFound.Label1.Caption := Format('File "%s" doesn''t exist. How would you like to fix this problem?', [PathName]);
      {Name is only the file name and extension}
      FileExName := ExtractFileName(PathName);
      if FileExists(RichEdit1.SelText) then goto Home;{check the path to see if the file exists}
      if Pos('@', RichEdit1.SelText) <> 0 then goto Home;
      if Pos('http://', RichEdit1.SelText) <> 0 then goto Home;
      if Pos('ftp://', RichEdit1.SelText) <> 0 then goto Home;
      DeadLinkCount := DeadLinkCount + 1;
      DeadLinkFound.ShowModal;
    end;
  Application.ProcessMessages;
  end;
end;

procedure TAppForm.Optimize1Execute(Sender: TObject);
var
i: integer;
f: file of byte;
begin
Stop2.Enabled := true;
ResetAll;
{get start time}
OptStart := Now;
{get each FindTxt and ReplaceTxt from FileList and RepList}
for i := 0 to FindList.Items.Count - 1 do
  begin
  FindTxt := FindList.Items[i];
  ReplaceTxt := RepList.Items.Strings[i];
    {Special characters that cannot be get from text are
    speccified here}
    if FindTxt = '_$RETURN' then FindTxt := #10#13;
    if FindTxt = '_$SPACE' then FindTxt := '  ';
    if FindTxt = '_$TAB' then FindTxt := ^I;
    if ReplaceTxt = '_$NULL' then ReplaceTxt := '';
    if OnOff.Items[i] = 'on' then FindAndReplace;
  end;
  { search for dead link<-------}
  FindTxt := '<img src="';
  ReplaceTxt := '"';
  FindDeadLink;
  FindTxt := '<a href="';
  ReplaceTxt := '"';
  FindDeadLink;
  {------------->}
{create temp file}
DeleteFile(TempFile);
TempFile := FFileName+'_$wpotemp.htm';
RichEdit1.Lines.SaveToFile(TempFile);
{Enable some buttons}
Results1.Enabled := true;
Before1.Enabled := true;
After1.Enabled := true;
Undo1.Enabled := true;
{hide total and current lines status}
Label2.Visible := false;
Label3.Visible := false;
Stop2.Enabled := false;

AssignFile(f, FFileName);
Reset(f);
Label1.Caption := Format('Download time before the optimization: %s seconds', [IntToStr(Round(FileSize(f)*8/SpinEdit1.Value))]);
CloseFile(f);

AssignFile(f, TempFile);
Reset(f);
Label6.Caption := Format('Download time after the optimization: %s seconds', [IntToStr(Round(FileSize(f)*8/SpinEdit1.Value))]);
CloseFile(f);

{Disable Optimize button}
Optimize1.Enabled := false;
Results1.Execute;
end;

procedure TAppForm.FileOpen1Execute(Sender: TObject);
begin
Close2.Execute;
  if OpenDialog.Execute then
  begin
    {load file}
    RichEdit1.Lines.LoadFromFile(OpenDialog.FileName);
    FFileName := OpenDialog.FileName;
    RichEdit1.SetFocus;
    RichEdit1.ReadOnly := ofReadOnly in OpenDialog.Options;
  end;
if FFileName <> '' then
begin
{change the form caption}
AppForm.Caption := Format('Web Page Optimizer - %s', [FFileName]);
DirectoryListBox1.Directory := ExtractFilePath(FFileName);
FileListBox1.FileName := ExtractFileName(FFileName);
ResetAll;
end;
end;

procedure TAppForm.FileSave1Execute(Sender: TObject);
begin
  {save to file}
  RichEdit1.Lines.SaveToFile(FFileName);
  RichEdit1.Modified := False;
  Close2.Execute;
end;

procedure TAppForm.FileSaveAs1Execute(Sender: TObject);
begin
  {save file as...}
  if SaveDialog.Execute then
  begin
    { if file exists then show the confirmation}
    if FileExists(SaveDialog.FileName) then
      if MessageDlg(Format(SOverwrite, [SaveDialog.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;
    RichEdit1.Lines.SaveToFile(SaveDialog.FileName);
    FFileName := SaveDialog.FileName;
    RichEdit1.Modified := False;
    Close2.Execute;
  end;
end;

procedure TAppForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TAppForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TAppForm.FormCreate(Sender: TObject);
begin
{ create FindList and RepList in which we gonna load the
ftaglist.ini and rtaglist.ini files.
in ftaglist the items we need to find and replace with rtaglist}
FindList := TListBox.CreateParented(Handle);
RepList := TListBox.CreateParented(Handle);
OnOff := TListBox.CreateParented(Handle);
OnOff.Items.LoadFromFile(ExtractFilePath(Application.ExeName)+'onoff.ini');
FindList.Items.LoadFromFile(ExtractFilePath(Application.ExeName)+'ftaglist.ini');
RepList.Items.LoadFromFile(ExtractFilePath(Application.ExeName)+'rtaglist.ini');
end;

procedure TAppForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{delete the temporary file on close}
DeleteFile(TempFile);
end;

procedure TAppForm.WebBrowser1ProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
begin
{show the progress bar and status in Label1}
if ProgressMax <> 0 then ProgressBar1.Max := ProgressMax;
ProgressBar1.Position := Progress;
end;

procedure TAppForm.DefaultBrowser1Click(Sender: TObject);
begin
{view the original file in default browser}
ShellExecute(Handle, nil, PChar(FFileName), nil, nil, SW_SHOWNORMAL);
end;

procedure TAppForm.DefaultBrowser2Click(Sender: TObject);
begin
{view the temporary optimized file in default browser}
DeleteFile(TempFile);
TempFile := ExtractFilePath(FFileName)+'_$wpotemp.htm';
RichEdit1.Lines.SaveToFile(TempFile);
ShellExecute(Handle, nil, PChar(TempFile), nil, nil, SW_SHOWNORMAL);
end;

procedure TAppForm.Undo1Execute(Sender: TObject);
begin
ResetAll;
{reload the RichEdit1 contents from original file "undo the optimization"}
RichEdit1.Lines.LoadFromFile(FFileName);
end;

procedure TAppForm.Results1Execute(Sender: TObject);
var
  f, t: file of byte;
  sizef, sizet : Longint;
begin
{get time when finished}
OptFin := Now;
{Display the results table:}
{original file}
  AssignFile(f, FFileName);
  Reset(f);
  sizef := FileSize(f);
  CloseFile(f);
{temp file}
  AssignFile(t, TempFile);
  Reset(t);
  sizet := FileSize(t);
  CloseFile(t);
 with Results do begin
   Caption := Format('Results Table for %s', [ExtractFileName(FFileName)]);
   Label1.Caption := Format('File Size before the optimization:  %d bytes', [sizef]);
   Label2.Caption := Format('File Size after the optimization:  %d bytes',[sizet]);
   Label3.Caption := Format('Total:  %d bytes freed up', [sizef - sizet]);
   Gauge1.Progress := Round((sizef - sizet)/ sizef * 100);
   Label5.Caption := 'Replaced and Deleted Entries: ' + IntToStr(B);
   Label6.Caption := Format('Time Elapsed:  %s', [TimeToStr(OptFin-OptStart)]);
   Label7.Caption := Format('Broken links found:  %d', [DeadLinkCount]);
   Label8.Caption := Format('fixed or deleted:  %d', [DeadLinkCount - SkipLinkCount]);
   Label9.Caption := Format('skipped:  %d', [SkipLinkCount]);
   Label10.Caption := AppForm.Label1.Caption;
   Label11.Caption := AppForm.Label6.Caption;
   ShowModal;
 end;
end;


procedure TAppForm.Before1Execute(Sender: TObject);
begin
{get the time when the web page started loading}
WebBrowser1.Navigate(FFileName);
end;

procedure TAppForm.After1Execute(Sender: TObject);
begin
{copy the Richedit in temporary file in directory where the FFileName exists}
ToolButton4.Click;
DeleteFile(TempFile);
TempFile := ExtractFilePath(FFileName)+'_$wpotemp.htm';
RichEdit1.Lines.SaveToFile(TempFile);
WebBrowser1.Navigate(TempFile);
end;

procedure TAppForm.Setting1Execute(Sender: TObject);
begin
SettingsForm.StringGrid1.Cells[0, 0] := 'On/Off';
SettingsForm.StringGrid1.Cells[1, 0] := 'Find';
SettingsForm.StringGrid1.Cells[2, 0] := 'Replace with';
SettingsForm.StringGrid1.RowCount := FindList.Items.Count + 1;
RefreshGrid;
SettingsForm.ShowModal;
end;

procedure TAppForm.RefreshGrid;
var
i: integer;
begin
SettingsForm.StringGrid1.RowCount := AppForm.Findlist.Items.Count + 1;
for i := 0 to FindList.Items.Count - 1 do begin
SettingsForm.StringGrid1.Cells[0, i+1] := OnOff.Items[i];
SettingsForm.StringGrid1.Cells[1, i+1] := FindList.Items[i];
SettingsForm.StringGrid1.Cells[2, i+1] := RepList.Items[i];
end;
end;

procedure TAppForm.ToolButton14Click(Sender: TObject);
begin
close;
end;

procedure TAppForm.Copy1Click(Sender: TObject);
begin
FileChange(Sender);
end;

procedure TAppForm.Move1Click(Sender: TObject);
begin
FileChange(Sender);
end;

procedure TAppForm.Rename1Click(Sender: TObject);
begin
FileChange(Sender);
end;

procedure TAppForm.Del1Click(Sender: TObject);
begin
if FFileName <> '' then
    if MessageDlg('Delete ' + FFileName + '?', mtConfirmation,
      [mbYes, mbNo], 0) = mrYes then
      if DeleteFile(FFileName) then Update;
end;

procedure TAppForm.View1Click(Sender: TObject);
begin
if View1.ImageIndex = 14 then begin
    DriveComboBox1.Visible := false;
    FilterComboBox1.Visible := false;
    FileListBox1.Visible := false;
    DirectoryListBox1.Visible := false;
    View1.ImageIndex := 15;
    end else begin
    DriveComboBox1.Visible := true;
    FilterComboBox1.Visible := true;
    FileListBox1.Visible := true;
    DirectoryListBox1.Visible := true;
    View1.ImageIndex := 14;
    end;
end;

procedure TAppForm.Close2Execute(Sender: TObject);
begin
FFileName := '';
RichEdit1.Lines.Clear;
Optimize1.Enabled := false;
Undo1.Enabled := false;
Results1.Enabled := false;
Before1.Enabled := false;
After1.Enabled := false;
WebBrowser1.Navigate(EmptyStr);
Label1.Caption := 'Download time before the optimization:';
Label6.Caption := 'Download time after the optimization:';
Caption := 'Web Page Optimizer';
end;

procedure TAppForm.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if KEY = VK_RETURN then begin
ResetAll;
RichEdit1.Lines.LoadFromFile(ComboBox1.Text);
FFileName := ComboBox1.Text;
RichEdit1.SetFocus;
end;
end;

procedure TAppForm.FileListBox1Click(Sender: TObject);
begin
ResetAll;
RichEdit1.Lines.LoadFromFile(FileListBox1.FileName);
FFileName := FileListBox1.FileName;
Caption := 'Web Page Optimizer - '+FFileName;
RichEdit1.SetFocus;
end;

procedure TAppForm.Stop2Execute(Sender: TObject);
begin
Stop := true;
WebBrowser1.Stop;
end;

end.
