unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ComCtrls;

type
  TDeadLinkFound = class(TForm)
    Accept: TButton;
    Edit1: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Label2: TLabel;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Label1: TLabel;
    Dr1: TDriveComboBox;
    Animate1: TAnimate;
    Button1: TButton;
    Button2: TButton;
    procedure AcceptClick(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    id: integer;
    FilesList, DirsList: TListBox;
    procedure GetFiles(const dir: String; filelist,dirlist: TStrings);
  public
    { Public declarations }
  end;

var
  DeadLinkFound: TDeadLinkFound;

implementation

uses LogoMain;

{$R *.DFM}

procedure TDeadLinkFound.GetFiles(const dir: String; filelist,dirlist: TStrings);
  var sr: TSearchRec;
  var templst: TStringList;
  var path,sfx: string;
  begin
    templst := TStringList.Create;
    try
      if (dir='') or (dir[Length(dir)] <> '\') then sfx := '\'
      else sfx := '';
      templst.Add(dir+sfx);
      while templst.Count > 0 do begin
        path := templst[0];
        templst.Delete(0);
        if FindFirst(path+'*.*',faAnyFile,sr)=0 then try
          repeat
            if (sr.Attr and faDirectory) = 0 then begin
              if filelist <> nil then
filelist.AddObject(path+sr.Name,Pointer(sr.Size));
            end
            else if sr.Name[1] <> '.' then begin
              templst.Add(path+sr.Name+'\');
              if dirlist <> nil then
dirlist.AddObject(path+sr.Name,Pointer(sr.Size));
            end;
          until FindNext(sr) <> 0;
        finally
          FindClose(sr);
        end;
      end;
    finally
      templst.Free;
    end;
end;


procedure TDeadLinkFound.AcceptClick(Sender: TObject);
var
i: integer;
Found: boolean;
begin
FilesList.Items.Clear;
DirsList.Items.Clear;
Found := true;
case id of
  1: begin
     with AppForm do
       begin
       RichEdit1.SelStart := LinkStPos;
       {set ReplaceTxt to '">' as we are going to delete the entire tag
       for eg.: <img src="cool.gif" width="34" height="34">}
       ReplaceTxt := '">';
       LinkEndPos := RichEdit1.FindText(ReplaceTxt, StartPos + Length(FindTxt), ToEnd,[]);
       RichEdit1.SelLength := LinkEndPos - LinkStPos + 2;
       if FindTxt = '<img src="' then RichEdit1.SelText := '' else RichEdit1.SelText := '<a>';
       {return the value of ReplaceTxt back to '"'
       so in the next loop it will stop at the second quotation mark
       <img src="cool.gif"}
       ReplaceTxt := '"';
       end;
     close;
     end;
  2: begin
     Animate1.Active := true;
     GetFiles(Dr1.Drive + ':\', FilesList.Items, DirsList.Items);
     for i := 0 to FilesList.Items.Count - 1 do begin
        if ExtractFileName(AppForm.PathName) = ExtractFileName(FilesList.Items[i]) then begin
        if MessageDlg(Format('The nearest file  "%s"  matching your request found in directory  "%s" . Would You like to CHANGE THE LINK to point to this file?', [AppForm.PathName, ExtractFilePath(FilesList.Items[i])]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        AppForm.RichEdit1.SelText := FilesList.Items[i];
        close;
        end else Found := false;
     end;
     {out of the loop now}
     if Found = false then MessageBox(Handle, 'File not found', 'Warning', 4144);
     Animate1.Active := false;
     end;
  3: begin
     Animate1.Active := true;
     GetFiles(Dr1.Drive + ':\', FilesList.Items, DirsList.Items);
     for i := 0 to FilesList.Items.Count - 1 do begin
        if ExtractFileName(AppForm.PathName) = ExtractFileName(FilesList.Items[i]) then begin
        if MessageDlg(Format('The nearest file  "%s"  matching your request found in directory  "%s" . Would You like to COPY THIS FILE to the new location to match the link?', [AppForm.PathName, ExtractFilePath(FilesList.Items[i])]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        CopyFile(PChar(FilesList.Items[i]), PChar(AppForm.RichEdit1.SelText), false);
        close;
        end else Found := false;
     end;
     {out of the loop now}
     if Found = false then MessageBox(Handle, 'File not found', 'Warning', 4144);
     Animate1.Active := false;
     end;
  4: begin
     Animate1.Active := true;
     GetFiles(Dr1.Drive + ':\', FilesList.Items, DirsList.Items);
     for i := 0 to FilesList.Items.Count - 1 do begin
        if ExtractFileName(AppForm.PathName) = ExtractFileName(FilesList.Items[i]) then begin
        if MessageDlg(Format('The nearest file  "%s"  matching your request found in directory  "%s" . Would you like to MOVE THIS FILE to the new location to match the link?', [AppForm.PathName, ExtractFilePath(FilesList.Items[i])]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        MoveFile(PChar(FilesList.Items[i]), PChar(AppForm.RichEdit1.SelText));
        close;
        end else Found := false;
     end;
     {out of the loop now}
     if Found = false then MessageBox(Handle, 'File not found', 'Warning', 4144);
     Animate1.Active := false;
     end;
  5: begin
     AppForm.RichEdit1.SelText := Edit1.Text;
     close;
     end;
  end;
end;


procedure TDeadLinkFound.RadioButton5Click(Sender: TObject);
begin
id := 5;
Edit1.Visible := true;
end;

procedure TDeadLinkFound.RadioButton4Click(Sender: TObject);
begin
id := 4;
Edit1.Visible := false;
end;

procedure TDeadLinkFound.RadioButton3Click(Sender: TObject);
begin
id := 3;
Edit1.Visible := false;
end;

procedure TDeadLinkFound.RadioButton2Click(Sender: TObject);
begin
id := 2;
Edit1.Visible := false;
end;

procedure TDeadLinkFound.RadioButton1Click(Sender: TObject);
begin
id := 1;
Edit1.Visible := false;
end;

procedure TDeadLinkFound.FormCreate(Sender: TObject);
begin
FilesList := TListBox.CreateParented(Handle);
DirsList := TListBox.CreateParented(Handle);
end;

procedure TDeadLinkFound.Button1Click(Sender: TObject);
begin
{close the form and search the next dead link}
AppForm.SkipLinkCount := AppForm.SkipLinkCount + 1;
close;
end;

procedure TDeadLinkFound.Button2Click(Sender: TObject);
begin
AppForm.SkipLinkCount := AppForm.DeadLinkCount;
AppForm.Stop := true;
close;
end;

end.
